Index: trunk/sources/HeuristicLab.Services.Deployment/3.3/App.config
===================================================================
--- trunk/sources/HeuristicLab.Services.Deployment/3.3/App.config	(revision 14195)
+++ 	(revision )
@@ -1,136 +1,0 @@
-<?xml version="1.0" encoding="utf-8"?>
-<configuration>
-  <system.diagnostics>
-    <!-- for logging. Make sure the IIS application user has write access rights for the output directory -->
-    <!--sources>
-      <source name="System.ServiceModel.MessageLogging" switchValue="Warning, ActivityTracing">
-        <listeners>
-          <add type="System.Diagnostics.DefaultTraceListener" name="Default">
-            <filter type="" />
-          </add>
-          <add name="ServiceModelMessageLoggingListener">
-            <filter type="" />
-          </add>
-        </listeners>
-      </source>
-      <source name="System.ServiceModel" switchValue="Warning, ActivityTracing"
-        propagateActivity="true">
-        <listeners>
-          <add type="System.Diagnostics.DefaultTraceListener" name="Default">
-            <filter type="" />
-          </add>
-          <add name="ServiceModelTraceListener">
-            <filter type="" />
-          </add>
-        </listeners>
-      </source>
-    </sources>
-    <sharedListeners>
-      <add initializeData="C:\inetpub\wwwroot\services.heuristiclab.com\Deployment-3.3\web_messages.svclog"
-        type="System.Diagnostics.XmlWriterTraceListener, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089"
-        name="ServiceModelMessageLoggingListener" traceOutputOptions="Timestamp">
-        <filter type="" />
-      </add>
-      <add initializeData="C:\inetpub\wwwroot\services.heuristiclab.com\Deployment-3.3\web_tracelog.svclog"
-        type="System.Diagnostics.XmlWriterTraceListener, System, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089"
-        name="ServiceModelTraceListener" traceOutputOptions="Timestamp">
-        <filter type="" />
-      </add>
-    </sharedListeners-->
-  </system.diagnostics>
-
-  <connectionStrings>
-    <add name="HeuristicLab.Authentication" connectionString="data source=.\SQLEXPRESS;Integrated Security=SSPI;Initial Catalog=HeuristicLab.Authentication"/>
-    <add name="HeuristicLab.Services.Deployment.DataAccess.Properties.Settings.HeuristicLab_DeploymentConnectionString" connectionString="Data Source=.\SQLEXPRESS;Integrated Security=SSPI;Initial Catalog=HeuristicLab.Deployment"/>
-  </connectionStrings>
-
-  <system.webServer>
-    <security>
-      <requestFiltering>
-        <requestLimits maxAllowedContentLength="100000000"/>
-      </requestFiltering>
-    </security>
-  </system.webServer>
-
-  <system.web>
-    <compilation debug="true"/>
-    <httpRuntime maxRequestLength="2097151"/>
-    <membership defaultProvider="AspNetSqlMembershipProvider">
-      <providers>
-        <clear/>
-        <add name="AspNetSqlMemberShipProvider" type="System.Web.Security.SqlMembershipProvider, System.Web, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" connectionStringName="HeuristicLab.Authentication" applicationName="HeuristicLab.Authentication" enablePasswordReset="false" enablePasswordRetrieval="false" passwordFormat="Hashed" requiresQuestionAndAnswer="false" requiresUniqueEmail="false" minRequiredNonalphanumericCharacters="0" minRequiredPasswordLength="8"/>
-      </providers>
-    </membership>
-    <authentication mode="Windows"/>
-    <roleManager enabled="true" defaultProvider="AspNetSqlRoleProvider">
-      <providers>
-        <clear/>
-        <add name="AspNetSqlRoleProvider" type="System.Web.Security.SqlRoleProvider, System.Web, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" connectionStringName="HeuristicLab.Authentication" applicationName="HeuristicLab.Authentication"/>
-      </providers>
-    </roleManager>
-  </system.web>
-
-  <!-- When deploying the service library project, the content of the config file must be added to the host's 
-  app.config file. System.Configuration does not support config files for libraries. -->
-  <system.serviceModel>
-    <bindings>
-      <wsHttpBinding>
-        <binding name="DefaultWsHttpBinding" maxBufferPoolSize="10000000" maxReceivedMessageSize="200000000">
-          <readerQuotas maxDepth="1000" maxStringContentLength="200000000" maxArrayLength="200000000" maxBytesPerRead="200000000" maxNameTableCharCount="16000"/>
-          <security mode="Message">
-            <message clientCredentialType="UserName"/>
-          </security>
-        </binding>
-      </wsHttpBinding>
-      <mexHttpBinding>
-        <binding name="DefaultMexHttpBinding"/>
-      </mexHttpBinding>
-    </bindings>
-
-    <diagnostics performanceCounters="Default">
-      <!--<messageLogging logMalformedMessages="false" logMessagesAtTransportLevel="false" />-->
-    </diagnostics>
-
-    <behaviors>
-      <endpointBehaviors>
-        <behavior name="DefaultEndpointBehavior">
-          <dataContractSerializer maxItemsInObjectGraph="1000000"/>
-        </behavior>
-      </endpointBehaviors>
-
-      <serviceBehaviors>
-        <behavior name="DefaultServiceBehavior">
-          <serviceMetadata httpGetEnabled="true"/>
-          <serviceDebug includeExceptionDetailInFaults="true"/>
-          <serviceCredentials>
-            <serviceCertificate findValue="localhost" storeLocation="LocalMachine" storeName="My" x509FindType="FindBySubjectName"/>
-            <userNameAuthentication userNamePasswordValidationMode="MembershipProvider" membershipProviderName="AspNetSqlMembershipProvider"/>
-          </serviceCredentials>
-          <serviceAuthorization principalPermissionMode="UseAspNetRoles" roleProviderName="AspNetSqlRoleProvider"/>
-        </behavior>
-      </serviceBehaviors>
-    </behaviors>
-
-    <services>
-      <service name="HeuristicLab.Services.Deployment.UpdateService" behaviorConfiguration="DefaultServiceBehavior">
-        <endpoint address="mex" binding="mexHttpBinding" bindingConfiguration="DefaultMexHttpBinding" contract="IMetadataExchange"/>
-        <endpoint behaviorConfiguration="DefaultEndpointBehavior" binding="wsHttpBinding" bindingConfiguration="DefaultWsHttpBinding" contract="HeuristicLab.Services.Deployment.IUpdateService"/>
-        <host>
-          <baseAddresses>
-            <add baseAddress="http://localhost:8732/Design_Time_Addresses/Deployment-3.3/UpdateService"/>
-          </baseAddresses>
-        </host>
-      </service>
-
-      <service name="HeuristicLab.Services.Deployment.AdminService" behaviorConfiguration="DefaultServiceBehavior">
-        <endpoint address="mex" binding="mexHttpBinding" bindingConfiguration="DefaultMexHttpBinding" contract="IMetadataExchange"/>
-        <endpoint behaviorConfiguration="DefaultEndpointBehavior" binding="wsHttpBinding" bindingConfiguration="DefaultWsHttpBinding" contract="HeuristicLab.Services.Deployment.IAdminService"/>
-        <host>
-          <baseAddresses>
-            <add baseAddress="http://localhost:8732/Design_Time_Addresses/Deployment-3.3/AdminService"/>
-          </baseAddresses>
-        </host>
-      </service>
-    </services>
-  </system.serviceModel>
-<startup><supportedRuntime version="v4.0" sku=".NETFramework,Version=v4.5"/></startup></configuration>
Index: trunk/sources/HeuristicLab.Services.Deployment/3.3/HeuristicLab.Services.Deployment-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Services.Deployment/3.3/HeuristicLab.Services.Deployment-3.3.csproj	(revision 14195)
+++ trunk/sources/HeuristicLab.Services.Deployment/3.3/HeuristicLab.Services.Deployment-3.3.csproj	(revision 14748)
@@ -121,5 +121,5 @@
   </ItemGroup>
   <ItemGroup>
-    <None Include="App.config" />
+    <None Include="app.config" />
   </ItemGroup>
   <ItemGroup>
@@ -130,4 +130,5 @@
   </ItemGroup>
   <ItemGroup>
+    <None Include="Web.config" />
     <None Include="HeuristicLab.snk" />
     <None Include="Properties\AssemblyInfo.cs.frame" />
Index: trunk/sources/HeuristicLab.Services.Deployment/3.3/Web.config
===================================================================
--- trunk/sources/HeuristicLab.Services.Deployment/3.3/Web.config	(revision 14748)
+++ trunk/sources/HeuristicLab.Services.Deployment/3.3/Web.config	(revision 14748)
@@ -0,0 +1,88 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<configuration>
+  <connectionStrings>
+    <add name="HeuristicLab.Authentication" connectionString="Data Source=.\SQLEXPRESS;Integrated Security=SSPI;Initial Catalog=HeuristicLab.Authentication" />
+    <add name="HeuristicLab.Services.Deployment.DataAccess.Properties.Settings.HeuristicLab_DeploymentConnectionString" connectionString="Data Source=.\SQLEXPRESS;Integrated Security=SSPI;Initial Catalog=HeuristicLab.Deployment"/>
+  </connectionStrings>
+
+  <system.webServer>
+    <security>
+      <requestFiltering>
+        <requestLimits maxAllowedContentLength="100000000"/>
+      </requestFiltering>
+    </security>
+  </system.webServer>
+
+  <system.web>
+    <compilation debug="true" />
+    <httpRuntime maxRequestLength="2097151"/>
+    <membership defaultProvider="AspNetSqlMembershipProvider">
+      <providers>
+        <clear />
+        <add name="AspNetSqlMembershipProvider" type="System.Web.Security.SqlMembershipProvider" connectionStringName="HeuristicLab.Authentication"
+             requiresQuestionAndAnswer="false" passwordFormat="Hashed" applicationName="HeuristicLab.Authentication" minRequiredPasswordLength="8"
+             minRequiredNonalphanumericCharacters="0" maxInvalidPasswordAttempts="5" />
+      </providers>
+    </membership>
+    <roleManager enabled="true" defaultProvider="AspNetSqlRoleProvider">
+      <providers>
+        <clear />
+        <add name="AspNetSqlRoleProvider" type="System.Web.Security.SqlRoleProvider" connectionStringName="HeuristicLab.Authentication" applicationName="HeuristicLab.Authentication" />
+      </providers>
+    </roleManager>
+  </system.web>
+
+  <system.serviceModel>
+    <services>
+      <service behaviorConfiguration="DefaultServiceBehavior" name="HeuristicLab.Services.Deployment.AdminService">
+        <endpoint binding="wsHttpBinding" bindingConfiguration="DefaultWsHttpBinding"
+          contract="HeuristicLab.Services.Deployment.IAdminService"/>
+        <host>
+          <baseAddresses>
+            <add baseAddress="http://localhost:8000/Deployment-3.3/AdminService.svc"/>
+          </baseAddresses>
+        </host>
+      </service>
+      <service behaviorConfiguration="DefaultServiceBehavior" name="HeuristicLab.Services.Deployment.UpdateService">
+        <endpoint binding="wsHttpBinding" bindingConfiguration="DefaultWsHttpBinding"
+          contract="HeuristicLab.Services.Deployment.IUpdateService"/>
+        <host>
+          <baseAddresses>
+            <add baseAddress="http://localhost:8000/Deployment-3.3/UpdateService.svc"/>
+          </baseAddresses>
+        </host>
+      </service>
+    </services>
+    <behaviors>
+      <serviceBehaviors>
+        <behavior name="DefaultServiceBehavior">
+          <serviceMetadata httpGetEnabled="true" />
+          <serviceDebug includeExceptionDetailInFaults="true" />
+          <serviceCredentials>
+            <serviceCertificate findValue="localhost" x509FindType="FindBySubjectName" />
+            <userNameAuthentication userNamePasswordValidationMode="MembershipProvider"
+              membershipProviderName="AspNetSqlMembershipProvider" />
+          </serviceCredentials>
+          <serviceAuthorization principalPermissionMode="UseAspNetRoles"
+            roleProviderName="AspNetSqlRoleProvider" />
+        </behavior>
+      </serviceBehaviors>
+    </behaviors>
+    <bindings>
+      <wsHttpBinding>
+        <binding name="DefaultWsHttpBinding" maxBufferPoolSize="2147483647"
+          maxReceivedMessageSize="2147483647">
+          <readerQuotas maxDepth="2147483647" maxStringContentLength="2147483647"
+            maxArrayLength="2147483647" maxBytesPerRead="2147483647" maxNameTableCharCount="2147483647" />
+          <security>
+            <message clientCredentialType="UserName" />
+          </security>
+        </binding>
+      </wsHttpBinding>
+    </bindings>
+  </system.serviceModel>
+
+  <startup>
+    <supportedRuntime version="v4.0" sku=".NETFramework,Version=v4.5" />
+  </startup>
+</configuration>
Index: trunk/sources/HeuristicLab.Services.Deployment/3.3/app.config
===================================================================
--- trunk/sources/HeuristicLab.Services.Deployment/3.3/app.config	(revision 14748)
+++ trunk/sources/HeuristicLab.Services.Deployment/3.3/app.config	(revision 14748)
@@ -0,0 +1,88 @@
+<?xml version="1.0" encoding="utf-8"?>
+<configuration>
+  <connectionStrings>
+    <add name="HeuristicLab.Authentication" connectionString="Data Source=.\SQLEXPRESS;Integrated Security=SSPI;Initial Catalog=HeuristicLab.Authentication" />
+    <add name="HeuristicLab.Services.Deployment.DataAccess.Properties.Settings.HeuristicLab_DeploymentConnectionString" connectionString="Data Source=.\SQLEXPRESS;Integrated Security=SSPI;Initial Catalog=HeuristicLab.Deployment"/>
+  </connectionStrings>
+
+  <system.webServer>
+    <security>
+      <requestFiltering>
+        <requestLimits maxAllowedContentLength="100000000"/>
+      </requestFiltering>
+    </security>
+  </system.webServer>
+
+  <system.web>
+    <compilation debug="true" />
+    <httpRuntime maxRequestLength="2097151"/>
+    <membership defaultProvider="AspNetSqlMembershipProvider">
+      <providers>
+        <clear />
+        <add name="AspNetSqlMembershipProvider" type="System.Web.Security.SqlMembershipProvider" connectionStringName="HeuristicLab.Authentication"
+             requiresQuestionAndAnswer="false" passwordFormat="Hashed" applicationName="HeuristicLab.Authentication" minRequiredPasswordLength="8"
+             minRequiredNonalphanumericCharacters="0" maxInvalidPasswordAttempts="5" />
+      </providers>
+    </membership>
+    <roleManager enabled="true" defaultProvider="AspNetSqlRoleProvider">
+      <providers>
+        <clear />
+        <add name="AspNetSqlRoleProvider" type="System.Web.Security.SqlRoleProvider" connectionStringName="HeuristicLab.Authentication" applicationName="HeuristicLab.Authentication" />
+      </providers>
+    </roleManager>
+  </system.web>
+
+  <system.serviceModel>
+    <services>
+      <service behaviorConfiguration="DefaultServiceBehavior" name="HeuristicLab.Services.Deployment.AdminService">
+        <endpoint binding="wsHttpBinding" bindingConfiguration="DefaultWsHttpBinding"
+          contract="HeuristicLab.Services.Deployment.IAdminService"/>
+        <host>
+          <baseAddresses>
+            <add baseAddress="http://localhost:8000/Deployment-3.3/AdminService.svc"/>
+          </baseAddresses>
+        </host>
+      </service>
+      <service behaviorConfiguration="DefaultServiceBehavior" name="HeuristicLab.Services.Deployment.UpdateService">
+        <endpoint binding="wsHttpBinding" bindingConfiguration="DefaultWsHttpBinding"
+          contract="HeuristicLab.Services.Deployment.IUpdateService"/>
+        <host>
+          <baseAddresses>
+            <add baseAddress="http://localhost:8000/Deployment-3.3/UpdateService.svc"/>
+          </baseAddresses>
+        </host>
+      </service>
+    </services>
+    <behaviors>
+      <serviceBehaviors>
+        <behavior name="DefaultServiceBehavior">
+          <serviceMetadata httpGetEnabled="true" />
+          <serviceDebug includeExceptionDetailInFaults="true" />
+          <serviceCredentials>
+            <serviceCertificate findValue="localhost" x509FindType="FindBySubjectName" />
+            <userNameAuthentication userNamePasswordValidationMode="MembershipProvider"
+              membershipProviderName="AspNetSqlMembershipProvider" />
+          </serviceCredentials>
+          <serviceAuthorization principalPermissionMode="UseAspNetRoles"
+            roleProviderName="AspNetSqlRoleProvider" />
+        </behavior>
+      </serviceBehaviors>
+    </behaviors>
+    <bindings>
+      <wsHttpBinding>
+        <binding name="DefaultWsHttpBinding" maxBufferPoolSize="2147483647"
+          maxReceivedMessageSize="2147483647">
+          <readerQuotas maxDepth="2147483647" maxStringContentLength="2147483647"
+            maxArrayLength="2147483647" maxBytesPerRead="2147483647" maxNameTableCharCount="2147483647" />
+          <security>
+            <message clientCredentialType="UserName" />
+          </security>
+        </binding>
+      </wsHttpBinding>
+    </bindings>
+  </system.serviceModel>
+
+  <startup>
+    <supportedRuntime version="v4.0" sku=".NETFramework,Version=v4.5" />
+  </startup>
+</configuration>