Index: branches/symbreg-factors-2650/HeuristicLab.Services.Hive.Web/Hive-3.3/Web.config
===================================================================
--- branches/symbreg-factors-2650/HeuristicLab.Services.Hive.Web/Hive-3.3/Web.config	(revision 14232)
+++ branches/symbreg-factors-2650/HeuristicLab.Services.Hive.Web/Hive-3.3/Web.config	(revision 14754)
@@ -1,3 +1,3 @@
-<?xml version="1.0"?>
+<?xml version="1.0" encoding="utf-8"?>
 <configuration>
   <configSections>
@@ -6,7 +6,9 @@
     </sectionGroup>
   </configSections>
+  
   <appSettings>
     <add key="ChartImageHandler" value="storage=file;timeout=20;dir=c:\TempImageFiles\;"/>
   </appSettings>
+  
   <applicationSettings>
     <HeuristicLab.Services.Hive.DataAccess.Settings>
@@ -19,32 +21,29 @@
     </HeuristicLab.Services.Hive.DataAccess.Settings>
   </applicationSettings>
+  
   <connectionStrings>
-    <add name="HeuristicLab.Authentication" connectionString="data source=localhost;Integrated Security=SSPI;Initial Catalog=HeuristicLab.Authentication"/>
-    <add name="HeuristicLab.Services.Hive.DataAccess.Settings.HeuristicLab_Hive_LinqConnectionString" connectionString="Data Source=localhost;Initial Catalog=HeuristicLab.Hive-3.3;Integrated Security=True;" providerName="System.Data.SqlClient"/>
+    <add name="HeuristicLab.Authentication" connectionString="Data Source=.\SQLEXPRESS;Integrated Security=SSPI;Initial Catalog=HeuristicLab.Authentication" />
+    <add name="HeuristicLab.Services.Hive.DataAccess.Settings.HeuristicLab_Hive_LinqConnectionString" connectionString=".\SQLEXPRESS;Initial Catalog=HeuristicLab.Hive-3.3;Integrated Security=SSPI" />
   </connectionStrings>
-  <!--
-    For a description of web.config changes see http://go.microsoft.com/fwlink/?LinkId=235367.
 
-    The following attributes can be set on the <httpRuntime> tag.
-      <system.Web>
-        <httpRuntime targetFramework="4.5" />
-      </system.Web>
-  -->
   <system.web>
-    <authentication mode="Forms"/>
+    <authentication mode="Forms" />
     <compilation debug="true" targetFramework="4.5">
       <assemblies>
-        <add assembly="System.Web.DataVisualization, Version=4.0.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35"/>
+        <add assembly="System.Web.DataVisualization, Version=4.0.0.0, Culture=neutral, PublicKeyToken=31BF3856AD364E35" />
       </assemblies>
     </compilation>
-    <membership>
+    <httpRuntime maxRequestLength="2097151"/>
+    <membership defaultProvider="AspNetSqlMembershipProvider">
       <providers>
-        <clear/>
-        <add name="AspNetSqlMembershipProvider" type="System.Web.Security.SqlMembershipProvider" connectionStringName="HeuristicLab.Authentication" enablePasswordRetrieval="false" enablePasswordReset="true" requiresQuestionAndAnswer="false" requiresUniqueEmail="false" maxInvalidPasswordAttempts="5" minRequiredPasswordLength="6" minRequiredNonalphanumericCharacters="0" passwordAttemptWindow="10" applicationName="HeuristicLab.Authentication"/>
+        <clear />
+        <add name="AspNetSqlMembershipProvider" type="System.Web.Security.SqlMembershipProvider" connectionStringName="HeuristicLab.Authentication"
+             requiresQuestionAndAnswer="false" requiresUniqueEmail="false" applicationName="HeuristicLab.Authentication" minRequiredPasswordLength="8"
+             minRequiredNonalphanumericCharacters="0" maxInvalidPasswordAttempts="5" />
       </providers>
     </membership>
-    <roleManager enabled="true">
+    <roleManager enabled="true" defaultProvider="AspNetSqlRoleProvider">
       <providers>
-        <clear/>
+        <clear />
         <add name="AspNetSqlRoleProvider" type="System.Web.Security.SqlRoleProvider" connectionStringName="HeuristicLab.Authentication" applicationName="HeuristicLab.Authentication"/>
       </providers>
@@ -55,58 +54,68 @@
       </controls>
     </pages>
-    <httpRuntime maxRequestLength="1048576"/>
   </system.web>
+  
   <system.serviceModel>
+    <serviceHostingEnvironment multipleSiteBindingsEnabled="true"/>
+    <services>
+      <service behaviorConfiguration="DefaultServiceBehavior" name="HeuristicLab.Services.Hive.HiveService">
+        <endpoint binding="wsHttpBinding" bindingConfiguration="WSHttpBinding_IHiveService"
+          name="WSHttpBinding_IHiveService" contract="HeuristicLab.Services.Hive.ServiceContracts.IHiveService" />
+        <endpoint address="net.tcp://localhost:8001/Hive-3.3/HiveService.svc"
+          binding="netTcpBinding" bindingConfiguration="NetBinding_IHiveService"
+          name="NetBinding_IHiveService" contract="HeuristicLab.Services.Hive.ServiceContracts.IHiveService" />
+        <host>
+          <baseAddresses>
+            <add baseAddress="http://localhost:8000/Hive-3.3/HiveService.svc" />
+          </baseAddresses>
+        </host>
+      </service>
+    </services>
+    <bindings>
+      <netTcpBinding>
+        <binding name="NetBinding_IHiveService" receiveTimeout="00:20:00"
+          sendTimeout="00:20:00" maxBufferPoolSize="2147483647" maxBufferSize="2147483647"
+          maxReceivedMessageSize="2147483647" portSharingEnabled="true">
+          <readerQuotas maxDepth="2147483647" maxStringContentLength="2147483647"
+            maxArrayLength="2147483647" maxBytesPerRead="2147483647" maxNameTableCharCount="2147483647" />
+          <security mode="TransportWithMessageCredential">
+            <message clientCredentialType="UserName" />
+          </security>
+        </binding>
+      </netTcpBinding>
+      <wsHttpBinding>
+        <binding name="WSHttpBinding_IHiveService" receiveTimeout="00:20:00"
+          sendTimeout="00:20:00" maxBufferPoolSize="2147483647" maxReceivedMessageSize="2147483647">
+          <readerQuotas maxDepth="2147483647" maxStringContentLength="2147483647"
+            maxArrayLength="2147483647" maxBytesPerRead="2147483647" maxNameTableCharCount="2147483647" />
+          <security>
+            <message clientCredentialType="UserName" />
+          </security>
+        </binding>
+      </wsHttpBinding>
+    </bindings>
+    <behaviors>
+      <serviceBehaviors>
+        <behavior name="DefaultServiceBehavior">
+          <serviceMetadata httpGetEnabled="true" />
+          <serviceDebug includeExceptionDetailInFaults="true" />
+          <serviceCredentials>
+            <serviceCertificate findValue="localhost" x509FindType="FindBySubjectName" />
+            <userNameAuthentication userNamePasswordValidationMode="MembershipProvider"
+              membershipProviderName="AspNetSqlMembershipProvider" />
+          </serviceCredentials>
+          <serviceAuthorization principalPermissionMode="UseAspNetRoles"
+            roleProviderName="AspNetSqlRoleProvider" />
+          <serviceSecurityAudit auditLogLocation="Application" suppressAuditFailure="false"
+            messageAuthenticationAuditLevel="SuccessOrFailure" />
+          <serviceThrottling maxConcurrentCalls="100" />
+        </behavior>
+      </serviceBehaviors>
+    </behaviors>
     <diagnostics performanceCounters="All">
       <messageLogging logEntireMessage="true" logMalformedMessages="true" logMessagesAtServiceLevel="true" logMessagesAtTransportLevel="true" maxMessagesToLog="3000"/>
     </diagnostics>
-    <bindings>
-      <wsHttpBinding>
-        <binding name="WSHttpBinding_IHiveService" messageEncoding="Text" receiveTimeout="00:35:00" sendTimeout="00:35:00" maxBufferPoolSize="2147483647" maxReceivedMessageSize="2147483647">
-          <readerQuotas maxDepth="2147483647" maxStringContentLength="2147483647" maxArrayLength="2147483647" maxBytesPerRead="2147483647" maxNameTableCharCount="2147483647"/>
-          <security mode="Message">
-            <transport clientCredentialType="Certificate"/>
-            <message clientCredentialType="UserName"/>
-          </security>
-        </binding>
-      </wsHttpBinding>
-      <netTcpBinding>
-        <binding name="NetTcpBinding_IHiveService" portSharingEnabled="true" receiveTimeout="00:35:00" sendTimeout="00:35:00" maxBufferPoolSize="2147483647" maxReceivedMessageSize="2147483647">
-          <readerQuotas maxDepth="2147483647" maxStringContentLength="2147483647" maxArrayLength="2147483647" maxBytesPerRead="2147483647" maxNameTableCharCount="2147483647"/>
-          <security mode="TransportWithMessageCredential">
-            <transport clientCredentialType="Certificate"/>
-            <message clientCredentialType="UserName"/>
-          </security>
-        </binding>
-      </netTcpBinding>
-    </bindings>
-    <behaviors>
-      <serviceBehaviors>
-        <behavior name="ServiceBehaviour_IHiveService">
-          <!-- To avoid disclosing metadata information, set the value below to false and remove the metadata endpoint above before deployment -->
-          <serviceMetadata httpGetEnabled="true" httpsGetEnabled="false"/>
-          <!-- To receive exception details in faults for debugging purposes, set the value below to true.  Set to false before deployment to avoid disclosing exception information -->
-          <serviceDebug httpHelpPageEnabled="true" includeExceptionDetailInFaults="true"/>
-          <serviceAuthorization principalPermissionMode="UseAspNetRoles" roleProviderName="AspNetSqlRoleProvider"/>
-          <serviceCredentials>
-            <serviceCertificate findValue="localhost" x509FindType="FindBySubjectName"/>
-            <userNameAuthentication userNamePasswordValidationMode="MembershipProvider" membershipProviderName="AspNetSqlMembershipProvider"/>
-          </serviceCredentials>
-          <serviceSecurityAudit auditLogLocation="Application" suppressAuditFailure="false" messageAuthenticationAuditLevel="SuccessOrFailure"/>
-          <serviceThrottling maxConcurrentCalls="100"/>
-          <dataContractSerializer maxItemsInObjectGraph="2147483647"/>
-        </behavior>
-      </serviceBehaviors>
-    </behaviors>
-    <services>
-      <service behaviorConfiguration="ServiceBehaviour_IHiveService" name="HeuristicLab.Services.Hive.HiveService">
-        <endpoint address="mexhttp" binding="mexHttpBinding" bindingConfiguration="" name="MexHttpEndpoint" contract="IMetadataExchange"/>
-        <endpoint address="mex" binding="mexTcpBinding" bindingConfiguration="" name="MexTcpEndpoint" contract="IMetadataExchange"/>
-        <endpoint address="" binding="wsHttpBinding" bindingConfiguration="WSHttpBinding_IHiveService" name="WSHttpBinding_IHiveService" contract="HeuristicLab.Services.Hive.ServiceContracts.IHiveService"/>
-        <endpoint address="net.tcp://services.heuristiclab.com/Hive-3.3/HiveService.svc" binding="netTcpBinding" bindingConfiguration="NetTcpBinding_IHiveService" name="NetBinding_IHiveService" contract="HeuristicLab.Services.Hive.ServiceContracts.IHiveService"/>
-      </service>
-    </services>
-    <serviceHostingEnvironment multipleSiteBindingsEnabled="true"/>
   </system.serviceModel>
+
   <system.webServer>
     <directoryBrowse enabled="true"/>